"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var add_metadata_1 = require("../add-metadata");
var base_validation_rule_1 = require("./base-validation-rule");
var LengthValidationRule = /** @class */ (function (_super) {
    __extends(LengthValidationRule, _super);
    function LengthValidationRule(min, max, key, options) {
        var _this = _super.call(this, key, options) || this;
        _this.min = min;
        _this.max = max;
        return _this;
    }
    LengthValidationRule.prototype.evaluate = function (value) {
        if (value === undefined || value === null)
            return false;
        if (this.min < value.length && value.length < this.max) {
            return false;
        }
        return true;
    };
    return LengthValidationRule;
}(base_validation_rule_1.BaseValidationRule));
function length(min, max, options) {
    return function (target, propertyKey) {
        add_metadata_1.addValidationRule(target, propertyKey, new LengthValidationRule(min, max, propertyKey, options));
    };
}
exports.length = length;
//# sourceMappingURL=length.js.map